var VK = {

  init: function () {},

  Auth: {
    login: function (callback, scope) {
      callback(!VK.Test.error
          ? {status: 'connected', session: {secret: 'oauth'}}
          : {status: 'not authorized', session: null});
    },
    logout: function (callback) {
      callback({});
    },
    revokeGrants: function (callback) {
      callback({});
    },
    getLoginStatus: function (callback) {
      callback(!VK.Test.error
          ? {status: 'connected', session: {secret: 'oauth'}}
          : {status: 'not authorized', session: null});
    },
    getSession: function () {}
  },

  Api: {
    call: function (method, params, callback) {
      if (VK.Test.error) {
        callback({
          error: {}
        })
      } else if (VK.Test.methods.indexOf(method) !== -1) {
        callback({
          response: {}
        });
      } else {
        // Do nothing: the test should trigger timeout.
      }
    }
  },

  Widgets: {
    AllowMessagesFromCommunity: function (element_id, options) {},
    Auth: function (element_id, options) {
      if (options) {
        if (options.onAuth) {
          options.onAuth({});
        } else if (options.authUrl) {
          VK.Test.redirect(options.authUrl);
        }
      }
    },
    Comments: function (element_id, options) {},
    Community: function (element_id, options) {},
    CommunityMessages: function (element_id, groupId, options) {
      if (VK.Test.error) {
        if (options && options.onCanNotWrite) {
          options.onCanNotWrite('reason');
        }
      }
    },
    ContactUs: function (element_id, options) {},
    Like: function (element_id, options) {},
    Poll: function (element_id, options) {},
    Post: function (element_id, options) {},
    Recommended: function (element_id, options) {},
    Share: function (element_id, options) {},
    Subscribe: function (element_id, options) {}
  },

  Share: {
    button: function (share_options, button_options, text) {}
  },

  Test: {
    error: false,
    redirect: function (url) {
      window.location = url;
    },
    methods: [
      'account.banUser',
      'account.changePassword',
      'account.getActiveOffers',
      'account.getAppPermissions',
      'account.getBanned',
      'account.getCounters',
      'account.getInfo',
      'account.getProfileInfo',
      'account.getPushSettings',
      'account.lookupContacts',
      'account.registerDevice',
      'account.saveProfileInfo',
      'account.setInfo',
      'account.setNameInMenu',
      'account.setOffline',
      'account.setOnline',
      'account.setPushSettings',
      'account.setSilenceMode',
      'account.unbanUser',
      'account.unregisterDevice',
      'apps.deleteAppRequests',
      'apps.get',
      'apps.getCatalog',
      'apps.getFriendsList',
      'apps.getLeaderboard',
      'apps.getScore',
      'apps.sendRequest',
      'audio.add',
      'audio.addAlbum',
      'audio.delete',
      'audio.deleteAlbum',
      'audio.edit',
      'audio.editAlbum',
      'audio.get',
      'audio.getAlbums',
      'audio.getBroadcastList',
      'audio.getById',
      'audio.getCount',
      'audio.getLyrics',
      'audio.getPopular',
      'audio.getRecommendations',
      'audio.getUploadServer',
      'audio.moveToAlbum',
      'audio.reorder',
      'audio.restore',
      'audio.save',
      'audio.search',
      'audio.setBroadcast',
      'auth.checkPhone',
      'auth.confirm',
      'auth.restore',
      'auth.signup',
      'board.addTopic',
      'board.closeTopic',
      'board.createComment',
      'board.deleteComment',
      'board.deleteTopic',
      'board.editComment',
      'board.editTopic',
      'board.fixTopic',
      'board.getComments',
      'board.getTopics',
      'board.openTopic',
      'board.restoreComment',
      'board.unfixTopic',
      'database.getChairs',
      'database.getCities',
      'database.getCitiesById',
      'database.getCountries',
      'database.getCountriesById',
      'database.getFaculties',
      'database.getRegions',
      'database.getSchoolClasses',
      'database.getSchools',
      'database.getStreetsById',
      'database.getUniversities',
      'docs.add',
      'docs.delete',
      'docs.edit',
      'docs.get',
      'docs.getById',
      'docs.getTypes',
      'docs.getUploadServer',
      'docs.getWallUploadServer',
      'docs.save',
      'docs.search',
      'execute',
      'fave.addGroup',
      'fave.addLink',
      'fave.addUser',
      'fave.getLinks',
      'fave.getMarketItems',
      'fave.getPhotos',
      'fave.getPosts',
      'fave.getUsers',
      'fave.getVideos',
      'fave.removeGroup',
      'fave.removeLink',
      'fave.removeUser',
      'friends.add',
      'friends.addList',
      'friends.areFriends',
      'friends.delete',
      'friends.deleteAllRequests',
      'friends.deleteList',
      'friends.edit',
      'friends.editList',
      'friends.get',
      'friends.getAppUsers',
      'friends.getByPhones',
      'friends.getLists',
      'friends.getMutual',
      'friends.getOnline',
      'friends.getRecent',
      'friends.getRequests',
      'friends.getSuggestions',
      'friends.search',
      'gifts.get',
      'groups.addLink',
      'groups.approveRequest',
      'groups.banUser',
      'groups.create',
      'groups.deleteLink',
      'groups.edit',
      'groups.editLink',
      'groups.editManager',
      'groups.editPlace',
      'groups.get',
      'groups.getBanned',
      'groups.getById',
      'groups.getCallbackConfirmationCode',
      'groups.getCallbackServerSettings',
      'groups.getCallbackSettings',
      'groups.getCatalog',
      'groups.getCatalogInfo',
      'groups.getInvitedUsers',
      'groups.getInvites',
      'groups.getMembers',
      'groups.getRequests',
      'groups.getSettings',
      'groups.invite',
      'groups.isMember',
      'groups.join',
      'groups.leave',
      'groups.removeUser',
      'groups.reorderLink',
      'groups.search',
      'groups.setCallbackServer',
      'groups.setCallbackServerSettings',
      'groups.setCallbackSettings',
      'groups.unbanUser',
      'likes.add',
      'likes.delete',
      'likes.getList',
      'likes.isLiked',
      'market.add',
      'market.addAlbum',
      'market.addToAlbum',
      'market.createComment',
      'market.delete',
      'market.deleteAlbum',
      'market.deleteComment',
      'market.edit',
      'market.editAlbum',
      'market.editComment',
      'market.get',
      'market.getAlbumById',
      'market.getAlbums',
      'market.getById',
      'market.getCategories',
      'market.getComments',
      'market.removeFromAlbum',
      'market.reorderAlbums',
      'market.reorderItems',
      'market.report',
      'market.reportComment',
      'market.restore',
      'market.restoreComment',
      'market.search',
      'messages.addChatUser',
      'messages.allowMessagesFromGroup',
      'messages.createChat',
      'messages.delete',
      'messages.deleteChatPhoto',
      'messages.deleteDialog',
      'messages.denyMessagesFromGroup',
      'messages.editChat',
      'messages.get',
      'messages.getById',
      'messages.getChat',
      'messages.getChatUsers',
      'messages.getDialogs',
      'messages.getHistory',
      'messages.getHistoryAttachments',
      'messages.getLastActivity',
      'messages.getLongPollHistory',
      'messages.getLongPollServer',
      'messages.isMessagesFromGroupAllowed',
      'messages.markAsAnsweredDialog',
      'messages.markAsImportant',
      'messages.markAsImportantDialog',
      'messages.markAsRead',
      'messages.removeChatUser',
      'messages.restore',
      'messages.search',
      'messages.searchDialogs',
      'messages.send',
      'messages.setActivity',
      'messages.setChatPhoto',
      'newsfeed.addBan',
      'newsfeed.deleteBan',
      'newsfeed.deleteList',
      'newsfeed.get',
      'newsfeed.getBanned',
      'newsfeed.getComments',
      'newsfeed.getLists',
      'newsfeed.getMentions',
      'newsfeed.getRecommended',
      'newsfeed.getSuggestedSources',
      'newsfeed.ignoreItem',
      'newsfeed.saveList',
      'newsfeed.search',
      'newsfeed.unignoreItem',
      'newsfeed.unsubscribe',
      'notes.add',
      'notes.createComment',
      'notes.delete',
      'notes.deleteComment',
      'notes.edit',
      'notes.editComment',
      'notes.get',
      'notes.getById',
      'notes.getComments',
      'notes.restoreComment',
      'notifications.get',
      'notifications.markAsViewed',
      'pages.clearCache',
      'pages.get',
      'pages.getHistory',
      'pages.getTitles',
      'pages.getVersion',
      'pages.parseWiki',
      'pages.save',
      'pages.saveAccess',
      'photos.confirmTag',
      'photos.copy',
      'photos.createAlbum',
      'photos.createComment',
      'photos.delete',
      'photos.deleteAlbum',
      'photos.deleteComment',
      'photos.edit',
      'photos.editAlbum',
      'photos.editComment',
      'photos.get',
      'photos.getAlbums',
      'photos.getAlbumsCount',
      'photos.getAll',
      'photos.getAllComments',
      'photos.getById',
      'photos.getChatUploadServer',
      'photos.getComments',
      'photos.getMarketAlbumUploadServer',
      'photos.getMarketUploadServer',
      'photos.getMessagesUploadServer',
      'photos.getNewTags',
      'photos.getOwnerPhotoUploadServer',
      'photos.getTags',
      'photos.getUploadServer',
      'photos.getUserPhotos',
      'photos.getWallUploadServer',
      'photos.makeCover',
      'photos.move',
      'photos.putTag',
      'photos.removeTag',
      'photos.reorderAlbums',
      'photos.reorderPhotos',
      'photos.report',
      'photos.reportComment',
      'photos.restore',
      'photos.restoreComment',
      'photos.save',
      'photos.saveMarketAlbumPhoto',
      'photos.saveMarketPhoto',
      'photos.saveMessagesPhoto',
      'photos.saveOwnerPhoto',
      'photos.saveWallPhoto',
      'photos.search',
      'places.add',
      'places.checkin',
      'places.getById',
      'places.getCheckins',
      'places.getTypes',
      'places.search',
      'polls.addVote',
      'polls.create',
      'polls.deleteVote',
      'polls.edit',
      'polls.getById',
      'polls.getVoters',
      'search.getHints',
      'stats.get',
      'stats.getPostReach',
      'stats.trackVisitor',
      'status.get',
      'status.set',
      'storage.get',
      'storage.getKeys',
      'storage.set',
      'users.get',
      'users.getFollowers',
      'users.getNearby',
      'users.getSubscriptions',
      'users.isAppUser',
      'users.report',
      'users.search',
      'utils.checkLink',
      'utils.getServerTime',
      'utils.resolveScreenName',
      'video.add',
      'video.addAlbum',
      'video.addToAlbum',
      'video.createComment',
      'video.delete',
      'video.deleteAlbum',
      'video.deleteComment',
      'video.edit',
      'video.editAlbum',
      'video.editComment',
      'video.get',
      'video.getAlbumById',
      'video.getAlbums',
      'video.getAlbumsByVideo',
      'video.getCatalog',
      'video.getCatalogSection',
      'video.getComments',
      'video.getNewTags',
      'video.getTags',
      'video.getUserVideos',
      'video.hideCatalogSection',
      'video.putTag',
      'video.removeFromAlbum',
      'video.removeTag',
      'video.reorderAlbums',
      'video.reorderVideos',
      'video.report',
      'video.reportComment',
      'video.restore',
      'video.restoreComment',
      'video.save',
      'video.search',
      'wall.createComment',
      'wall.delete',
      'wall.deleteComment',
      'wall.edit',
      'wall.editComment',
      'wall.get',
      'wall.getById',
      'wall.getComments',
      'wall.getReposts',
      'wall.pin',
      'wall.post',
      'wall.reportComment',
      'wall.reportPost',
      'wall.repost',
      'wall.restore',
      'wall.restoreComment',
      'wall.search',
      'wall.unpin',
      'widgets.getComments',
      'widgets.getPages'
    ]
  }
};
